import React from 'react';
import './avatarImg.scss';
function substring(str, len, hasDot) {
    if (!str) {
        return "";
    }
    var newLength = 0;
    var newStr = "";
    var chineseRegex = /[^\x00-\xff]/g;
    var singleChar = "";
    var strLength = str.replace(chineseRegex, "**").length;
    for (var i = 0; i < strLength; i++) {
        singleChar = str.charAt(i).toString();
        if (singleChar.match(chineseRegex) != null) {
            newLength += 2;
        }
        else {
            newLength++;
        }
        if (newLength > len) {
            break;
        }
        newStr += singleChar;
    }
    if (hasDot && strLength > len) {
        newStr += "...";
    }
    return newStr;
}
export default function AvatarImg(_a) {
    var size = _a.size, name = _a.name, src = _a.src, color = _a.color, hasAvatar = _a.hasAvatar;
    var subName = '';
    try {
        switch (size) {
            case 20:
                subName = substring(name, 2, false);
                break;
            case 30:
                subName = substring(name, 2, false);
                break;
            case 28:
                subName = substring(name, 2, false);
                break;
            case 50:
                subName = substring(name, 6, false);
                break;
            case 60:
                subName = substring(name, 6, false);
            case 64:
                subName = substring(name, 6, false);
                break;
            case 80:
                subName = substring(name, 6, false);
                break;
            case 100:
                subName = substring(name, 8, false);
                break;
            case 120:
                subName = substring(name, 8, false);
                break;
            case 130:
                subName = substring(name, 8, false);
                break;
            case 150:
                subName = substring(name, 10, false);
                break;
            default:
                subName = name;
                break;
        }
    }
    catch (error) {
        throw error;
    }
    var classString = 'up-avatar up-avatar_size-' + size + ' ';
    var spanObject = { backgroundColor: color, display: !hasAvatar ? 'inline-block' : 'none' };
    var imgObject = { display: !hasAvatar ? 'none' : 'inline-block', height: size + 'px', width: size + 'px' };
    return (React.createElement("span", { className: "avatar-img-wrap", style: { display: 'inline-block', height: size + 'px' } },
        React.createElement("img", { style: imgObject, className: classString, src: src }),
        React.createElement("span", { style: spanObject, className: classString },
            " ",
            subName,
            " ")));
}
