var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import React, { Component } from 'react';
import './index.scss';
import { getBSGlobal, getUserInfo } from './helper/index';
import AvatarImg from './avatarImg/avatarImg';
import ToolTip from '@beisen/tool-tip';
import { jumpPerson } from './helper/jumpToPersonHome';
var HonorCard = /** @class */ (function (_super) {
    __extends(HonorCard, _super);
    function HonorCard() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        // 跳转到个人主页
        _this.goToHomePage = function () {
            var UserId = _this.props.UserId;
            jumpPerson(UserId, 1);
        };
        // 跳转到勋章墙
        _this.goToMedalPage = function () {
            var loginId = getUserInfo().Id;
            var medalState = 0;
            var webPath = getBSGlobal('apiPath');
            var UserId = _this.props.UserId;
            var iframeBoxUrl = webPath + "/" + loginId + "/UpaasHome#";
            if (webPath.indexOf('tita') > -1) {
                iframeBoxUrl = webPath + "/u/" + loginId + "/Home#";
            }
            if (webPath.indexOf('italent') > -1) {
                iframeBoxUrl = webPath + "/" + loginId + "/ITalentHome#";
            }
            var medalPageUrl = "" + iframeBoxUrl + encodeURIComponent("widget/italent?iTalentFrameType=iframe&iTalentNavId=&iTalentFrame=" + encodeURIComponent(getBSGlobal('titaHost') + "/" + loginId + "/UpaasPortalPlus#/medalwall?targetTabIndex=" + medalState + "&toUserId=" + UserId));
            window.open(medalPageUrl, '_blank');
        };
        // 荣誉卡片顶部
        _this.genhonorHeader = function () {
            var _a = _this.props, _b = _a.avatar, hasAvatar = _b.hasAvatar, color = _b.color, img = _b.img, UserName = _a.UserName, Dept = _a.Dept, _c = _a.Medals, Medals = _c === void 0 ? [] : _c, _d = _a.Tags, Tags = _d === void 0 ? [] : _d;
            var medalLength = Medals.length;
            return (React.createElement("div", { className: "honor-card-header " + (medalLength == 0 ? 'no-medal-header' : '') },
                _this.genTagItem(Tags),
                React.createElement("div", { className: "honor-avatar-bg " + (medalLength == 0 ? 'no-medal-avatar-bg' : '') },
                    React.createElement("div", { className: "honor-card-avatar " + (medalLength == 0 ? 'no-medal-avatar' : '') },
                        React.createElement(AvatarImg, { size: 80, name: UserName, src: img, color: color, hasAvatar: hasAvatar }))),
                React.createElement(ToolTip, { title: UserName + "\u2022" + Dept },
                    React.createElement("div", { className: "honor-user " + (medalLength == 0 ? 'no-medal-honor-user' : '') },
                        React.createElement("span", { className: 'honor-user-name' },
                            UserName,
                            " ",
                            React.createElement("span", { className: 'bold-dot' })),
                        React.createElement("span", { className: 'honor-user-department' },
                            " ",
                            Dept))),
                React.createElement("div", { className: 'card-medal-name', style: { display: medalLength == 0 ? 'none' : '' } },
                    React.createElement("span", { className: 'medal-name-bg-left' }),
                    React.createElement("span", { className: 'medal-name-center' }, Medals[0] && Medals[0].MedalName),
                    React.createElement("span", { className: 'medal-name-bg-right' }))));
        };
        _this.genHonorCenter = function () {
            var _a = _this.props, _b = _a.MedalNum, MedalNum = _b === void 0 ? '' : _b, _c = _a.TagNum, TagNum = _c === void 0 ? '' : _c, _d = _a.RedPackNum, RedPackNum = _d === void 0 ? '' : _d, _e = _a.BlessingNum, BlessingNum = _e === void 0 ? '' : _e;
            var _f = _this, goToMedalPage = _f.goToMedalPage, goToHomePage = _f.goToHomePage;
            return (React.createElement("div", { className: 'honor-card-center' },
                _this.getHonorCount(MedalNum, '勋章', 'medal', goToMedalPage),
                _this.getHonorCount(TagNum, '标签', 'tag', goToHomePage),
                _this.getHonorCount(BlessingNum, '祝福'),
                _this.getHonorCount(RedPackNum, '红包')));
        };
        _this.genHonorBottom = function () {
            var _a = _this.props.Medals, Medals = _a === void 0 ? [] : _a;
            var medalLength = Medals.length;
            return (React.createElement("div", null,
                React.createElement("div", { className: 'honor-card-bottom', style: { display: medalLength == 0 ? 'none' : '' } },
                    _this.genMedalItem('left', Medals[1]),
                    _this.genMedalItem('center', Medals[0]),
                    _this.genMedalItem('right', Medals[2])),
                React.createElement("div", { className: 'no-medal-bottom', style: { display: medalLength == 0 ? '' : 'none' } },
                    React.createElement("div", { className: 'no-medal-img' }),
                    React.createElement("div", { className: 'no-medal-words' }, "\u8FD8\u6CA1\u83B7\u5F97\u52CB\u7AE0\u54E6~"))));
        };
        // 标签，勋章，祝福，红包数
        _this.getHonorCount = function (honorNum, honorName, honorClassName, gotoPage) {
            return (React.createElement("span", { className: "honor-variety honor-variety-" + honorClassName, onClick: gotoPage },
                React.createElement("div", { className: "honor-count " + honorClassName + "-count" }, "" + (honorNum >= 99 ? '99+' : honorNum)),
                React.createElement("div", { className: "honor-variety-name " + honorClassName + "-name" }, honorName)));
        };
        // 勋章列表
        _this.genMedalItem = function (medalPos, medalsArray) {
            if (medalsArray) {
                var PicUrl = medalsArray.PicUrl, MedalName = medalsArray.MedalName, MedalType = medalsArray.MedalType;
                return (React.createElement("span", { className: medalPos + "-medal" },
                    React.createElement("img", { className: medalPos + "-medal-icon", src: MedalType == 4 ? PicUrl : PicUrl + ".svg" }),
                    React.createElement(ToolTip, { title: MedalName, tipsPosition: 'bottom' },
                        React.createElement("div", { className: medalPos + "-medal-name" }, MedalName))));
            }
            else {
                return (React.createElement("span", { className: medalPos + "-medal" },
                    React.createElement("div", { className: medalPos + "-medal-icon-div" }),
                    React.createElement("div", { className: "empty-" + medalPos + "-medal-name" }, "\u865A\u4F4D\u4EE5\u5F85")));
            }
        };
        // 标签列表
        _this.genTagItem = function (tagArray) {
            var length = tagArray.length;
            var tagList = tagArray.map(function (item, index) { return (React.createElement("span", { className: "tags-outer", ref: 'tagItem', key: index },
                React.createElement(ToolTip, { title: item.TagName },
                    React.createElement("span", { className: 'honor-card-tags', onClick: _this.goToHomePage },
                        React.createElement("span", null,
                            " ",
                            item.TagName))))); });
            // 有一个或两个标签时，标签位置
            if (length <= 2) {
                return React.createElement("div", { className: 'tag-item-less-than-three' }, tagList);
            }
            // 有四个标签时，标签位置
            if (length == 4) {
                return React.createElement("div", { className: 'tag-item-equal-to-four' }, tagList);
            }
            // 有三个标签时，标签位置
            if (length == 3) {
                return React.createElement("div", { className: 'tag-item-equal-to-three' }, tagList);
            }
        };
        return _this;
    }
    HonorCard.prototype.render = function () {
        var isLeaved = this.props.isLeaved;
        return (React.createElement("div", { className: 'honor-card' },
            React.createElement("div", { className: 'honor-card-container', onMouseEnter: this.props.onMouseEnter, onMouseLeave: this.props.onMouseLeave }, !isLeaved ? (React.createElement("div", { className: 'honor-content' },
                this.genhonorHeader(),
                this.genHonorCenter(),
                this.genHonorBottom())) : (React.createElement("div", { className: 'demission' },
                React.createElement("div", { className: 'demission-img' }),
                React.createElement("div", { className: 'demission-words' }, "\u8BE5\u5458\u5DE5\u5DF2\u7ECF\u79BB\u804C\u5566~"))))));
    };
    return HonorCard;
}(Component));
export default HonorCard;
