var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
/*
 * @Author: yinjikai
 * @Date: 2018-08-30 10:47:00
 * @Last Modified by: yinjikai
 * @Last Modified time: 2018-12-17 16:21:38
 * @desc 简版头像组件
 */
// test ci 4
import React, { Component } from 'react';
import ToolTip from '@beisen/tool-tip';
import RenderInBody from './utils/renderInbody';
import { sendBlessing, recieveBlssings, getUserInfo, getBSGlobal, getCloudApiUrl, takerCloud, jumpToPersonalHomePage, } from './utils/index';
import './index.scss';
var Avatar = /** @class */ (function (_super) {
    __extends(Avatar, _super);
    function Avatar(props) {
        var _this = _super.call(this, props) || this;
        // 生成头像字符串
        _this.genSubName = function (name, size) {
            var subName = '';
            switch (Number(size)) {
                case 20:
                case 26:
                case 28:
                case 30:
                case 40:
                    subName = _this.genSubString(name, 2, false);
                    break;
                case 50:
                    subName = _this.genSubString(name, 6, false);
                    break;
                case 60:
                case 64:
                case 76:
                case 80:
                    subName = _this.genSubString(name, 6, false);
                    break;
                case 100:
                case 120:
                case 130:
                    subName = _this.genSubString(name, 8, false);
                    break;
                case 150:
                    subName = _this.genSubString(name, 10, false);
                    break;
                default:
                    subName = name;
                    break;
            }
            return subName;
        };
        _this.genSubString = function (str, len, hasDot) {
            if (!str) {
                return '';
            }
            var newLength = 0;
            var newStr = '';
            var chineseRegex = /[^\x00-\xff]/g;
            var singleChar = '';
            var strLength = str.replace(chineseRegex, '**').length;
            for (var i = 0; i < strLength; i++) {
                singleChar = str.charAt(i).toString();
                if (singleChar.match(chineseRegex) != null) {
                    newLength += 2;
                }
                else {
                    newLength++;
                }
                if (newLength > len) {
                    break;
                }
                newStr += singleChar;
            }
            if (hasDot && strLength > len) {
                newStr += '...';
            }
            return newStr;
        };
        // 送祝福
        _this.sendBlessing = function (userId) { return function () {
            sendBlessing(userId, _this.props.blessingType);
        }; };
        // 生成挂件
        _this.genIcon = function () {
            var _a = _this.props, blessingType = _a.blessingType, userId = _a.userId, size = _a.size, udc = _a.udc;
            var isSelf = getBSGlobal('loginUserInfo').Id == userId;
            var blessingudc = udc && udc.bless && encodeURIComponent(JSON.stringify(udc.bless));
            var iconSize = _this.getAvatarConfig(size).iconSize;
            var iconStyle = { width: iconSize, height: iconSize };
            var blessingTypes = ['', '_birthday', '_anniversary', '_teachersday'];
            var _blessingType = blessingTypes[blessingType];
            var _blesingTitle = blessingType == 1
                ? '今天是ta的生日，点挂饰可以送祝福哦'
                : '今天是ta的入职纪念日，点挂饰可以送祝福哦';
            var _blessingForSelf = blessingType == 1
                ? '生日快乐！点挂饰可以查看祝福哦'
                : '入职纪念日快乐！点挂饰可以查看祝福哦';
            if (blessingTypes && blessingType < 3) {
                return (React.createElement(ToolTip, { title: isSelf ? _blessingForSelf : _blesingTitle }, !isSelf ? (React.createElement("i", { className: _blessingType, onClick: _this.sendBlessing(userId), style: iconStyle, "data-udc": blessingudc })) : (React.createElement("i", { className: _blessingType, onClick: function () { return recieveBlssings(userId, _this.props.blessingType); }, style: iconStyle, "data-udc": blessingudc }))));
            }
            // if (blessingType == 3) {
            //   return (
            //     <ToolTip title="北森讲师">
            //       <i className={_blessingType} style={iconStyle} />
            //     </ToolTip>
            //   );
            // }
        };
        _this.getAvatarConfig = function (size) {
            var _iconsize = 16;
            var _fontSize = 12;
            switch (size) {
                case 20:
                case 26:
                case 28:
                case 30:
                    _iconsize = 16;
                    _fontSize = 12;
                    break;
                case 40:
                case 50:
                case 60:
                case 64:
                    _iconsize = 25;
                    _fontSize = 14;
                    break;
                case 76:
                case 80:
                    _iconsize = 40;
                    _fontSize = 16;
                    break;
                case 100:
                case 120:
                case 130:
                    _iconsize = 50;
                    _fontSize = 18;
                    break;
                case 150:
                    _iconsize = 80;
                    _fontSize = 20;
                    break;
                default:
                    _iconsize = 25;
                    _fontSize = 12;
                    break;
            }
            return {
                iconSize: _iconsize,
                fontSize: _fontSize,
            };
        };
        _this.handleJumpToMedalWall = function (e) {
            e.stopPropagation();
            var userId = _this.props.userId;
            e.nativeEvent.stopPropagation();
            var loginId = getUserInfo().Id;
            var webPath = getBSGlobal('apiPath');
            var iframeBoxUrl = webPath + "/" + loginId + "/UpaasHome#";
            if (webPath.indexOf('tita') > -1) {
                iframeBoxUrl = webPath + "/u/" + loginId + "/Home#";
            }
            if (webPath.indexOf('italent') > -1) {
                iframeBoxUrl = webPath + "/" + loginId + "/ITalentHome#";
            }
            var url = "" + iframeBoxUrl + encodeURIComponent("widget/italent?iTalentFrameType=iframe&iTalentNavId=&iTalentFrame=" + encodeURIComponent(getBSGlobal('titaHost') + "/" + loginId + "/UpaasPortalPlus#/medalwall?targetTabIndex=" + 0 + "&toUserId=" + userId));
            window.open(url, '_blank');
        };
        _this.genMedal = function () {
            var _a = _this.props, medalurl = _a.medalurl, decorationType = _a.decorationType, udc = _a.udc, handleMedalIconMouseHover = _a.handleMedalIconMouseHover, handleMedalIconMouseLeave = _a.handleMedalIconMouseLeave;
            var medalUdc = udc && udc.medal && encodeURIComponent(JSON.stringify(udc.medal));
            if (decorationType !== 2 && decorationType !== 3) {
                return;
            }
            return (React.createElement("div", { className: '_medal-icon-wrap', onMouseEnter: handleMedalIconMouseHover, onMouseLeave: handleMedalIconMouseLeave }, decorationType == 2 ? (React.createElement("div", { className: '_company-medal-wrap', "data-udc": medalUdc, onClick: _this.handleJumpToMedalWall },
                React.createElement("div", { className: '_company-medal-img' }))) : (React.createElement("div", { className: '_system-medal-wrap', "data-udc": medalUdc, onClick: _this.handleJumpToMedalWall },
                React.createElement("img", { src: medalurl, className: '_medal-icon' })))));
        };
        _this.onMouseEnterAvatar = function () {
            if (!_this.state.HonorCard) {
                return;
            }
            var _a = _this.getPosition(), left = _a.left, top = _a.top;
            _this.getHonorCardData(_this.setHonorCardPosition(left, top));
        };
        _this.handleMouseOverAvatar = function (e) {
            if (!_this.state._top || !_this.state._left) {
                var _a = _this.getPosition(e.clientY, e.clientX), left = _a.left, top_1 = _a.top;
                _this.setState({
                    _left: left,
                    _top: top_1,
                    showHonorCard: true,
                });
            }
        };
        _this.onMouseLeaveAvatar = function () {
            setTimeout(function () {
                if (_this.showCard) {
                    return '';
                }
                _this.setState({
                    showHonorCard: false,
                });
            }, 500);
        };
        _this.onMouseEnterCard = function () {
            _this.showCard = true;
            _this.setState({
                showHonorCard: true,
            });
        };
        _this.getPosition = function () {
            var _window_width = window.innerWidth;
            var _window_height = window.innerHeight;
            var minWidth = 282;
            var minHeight = 362;
            var _a = _this.avatar.getBoundingClientRect(), right = _a.right, left = _a.left, top = _a.top;
            if (top + minHeight > _window_height) {
                top = top - (top + minHeight - _window_height) + window.pageYOffset;
            }
            else {
                top = top + window.pageYOffset;
            }
            if (right + minWidth + 5 > _window_width) {
                // 向左显示
                left = left - minWidth - 5;
            }
            else {
                // 向右显示
                left = right + 5;
            }
            return {
                left: left,
                top: top,
            };
        };
        _this.onMouseLeaveCard = function () {
            _this.showCard = false;
            _this.onMouseLeaveAvatar();
        };
        _this.renderHonorCard = function () {
            var _a = _this.state, HonorCard = _a.HonorCard, honorCardConfig = _a.honorCardConfig, showHonorCard = _a.showHonorCard, _top = _a._top, _left = _a._left;
            if (!HonorCard || !showHonorCard) {
                return;
            }
            return (showHonorCard && (React.createElement(RenderInBody, { id: '__honorCard_container', top: _top, left: _left },
                React.createElement(HonorCard, __assign({}, honorCardConfig, { avatar: _this.props.avatar, onMouseEnter: _this.onMouseEnterCard, onMouseLeave: _this.onMouseLeaveCard })))));
        };
        _this.handleAvatarClick = function () {
            var _a = _this.props, userId = _a.userId, enableJump = _a.enableJump;
            if (enableJump && userId) {
                jumpToPersonalHomePage(userId, 1);
            }
        };
        _this.state = {
            _left: 0,
            _top: 0,
        };
        var showHonorCard = props.showHonorCard, decorationType = props.decorationType, simpleMode = props.simpleMode;
        if (!simpleMode && decorationType == 1) {
            // loadFeaturesCmp();
        }
        if (showHonorCard) {
            import('./HonorCard/index').then(function (HonorCard) {
                _this.setState({
                    HonorCard: HonorCard.default,
                });
            });
        }
        _this.state = {
            showHonorCard: false,
            HonorCard: '',
        };
        return _this;
    }
    Avatar.prototype.setHonorCardPosition = function (left, top) {
        this.setState({
            _left: left,
            _top: top,
            showHonorCard: true,
        });
    };
    Avatar.prototype.getHonorCardData = function (callback) {
        var _this = this;
        var userId = this.props.userId;
        var url = "" + getCloudApiUrl("/UPaaSCoreMRest/100000/UserProerty/GetUserHonorCard?userId=" + userId);
        takerCloud(url, 'GET').then(function (res) {
            if (res.HttpCode == 200) {
                _this.setState({
                    honorCardConfig: res.OperationObject,
                }, function () {
                    callback && callback();
                });
            }
        });
    };
    Avatar.prototype.render = function () {
        var _this = this;
        var _a = this.props, avatar = _a.avatar, size = _a.size, name = _a.name, blessingType = _a.blessingType, decorationType = _a.decorationType, simpleMode = _a.simpleMode, enableJump = _a.enableJump;
        var hasAvatar = avatar.hasAvatar, color = avatar.color, img = avatar.img, medium = avatar.medium;
        var subName = this.genSubName(name, size);
        var fontSize = this.getAvatarConfig(size).fontSize;
        return (React.createElement("div", { className: "__common-user-avatar-wrap size-" + size, ref: function (ref) { return (_this.avatar = ref); }, style: { width: size, height: size, fontSize: fontSize + "px" } },
            !simpleMode && !!blessingType && decorationType == 1 && this.genIcon(),
            !simpleMode &&
                (decorationType == 2 || decorationType == 3) &&
                this.genMedal(),
            hasAvatar ? (React.createElement("div", { className: "common-user-avatar size-" + size, style: {
                    width: size,
                    height: size,
                    cursor: "" + (enableJump ? 'pointer' : ''),
                }, onMouseEnter: this.onMouseEnterAvatar, onMouseLeave: this.onMouseLeaveAvatar, onClick: this.handleAvatarClick },
                React.createElement("img", { src: img || medium, className: 're-img-avatar' }))) : (React.createElement("div", { className: "common-user-avatar no-avatar size-" + size + " ", style: {
                    backgroundColor: "" + color,
                    lineHeight: size + "px",
                    cursor: "" + (enableJump ? 'pointer' : ''),
                }, onMouseEnter: this.onMouseEnterAvatar, onMouseLeave: this.onMouseLeaveAvatar, onClick: this.handleAvatarClick },
                React.createElement("span", null, subName))),
            this.renderHonorCard()));
    };
    return Avatar;
}(Component));
window.AvatarCmp = Avatar;
export default Avatar;
